> For the complete documentation index, see [llms.txt](https://boxlang.ortusbooks.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/async/executornew.md).

# ExecutorNew

Creates and registers a new executor by name and type.

The return value is an BoxExecutor object that can be used to interact with the executor.

Available types are:

* "cached" - Creates a cached thread pool executor.
* "fixed" - Creates a fixed thread pool executor.
* "fork\_join" - Creates a fork join pool executor.
* "scheduled" - Creates a scheduled thread pool executor.
* "single" - Creates a single thread executor.
* "virtual" - Creates a virtual thread executor.
* "work\_stealing" - Creates a work stealing thread pool executor.

## Method Signature

```
ExecutorNew(name=[string], type=[string], maxThreads=[integer])
```

### Arguments

| Argument     | Type      | Required | Description                                               | Default |
| ------------ | --------- | -------- | --------------------------------------------------------- | ------- |
| `name`       | `string`  | `true`   | The name of the executor to create if not already created |         |
| `type`       | `string`  | `true`   | The type of executor to create                            |         |
| `maxThreads` | `integer` | `false`  |                                                           | `10`    |

## Examples

### Create a new executor service

```java
exec = executorNew( "myPool", "fixed", 4 );
writeOutput( exec.name() & "," & exec.type() );

```

Result: myPool,FIXED

### Available executor types

```java
executorNew( "cachedPool", "cached" );
executorNew( "singleThread", "single" );
executorNew( "virtualThreads", "virtual" );
writeOutput( executorHas( "cachedPool" ) & executorHas( "singleThread" ) & executorHas( "virtualThreads" ) );

```

Result: truetruetrue

### Cached thread pool (unbounded)

```java
exec = executorNew( "workPool", "cached" );
writeOutput( exec.type() );

```

Result: CACHED

## Related

* [AsyncAll](/boxlang-language/reference/built-in-functions/async/asyncall.md)
* [AsyncAllApply](/boxlang-language/reference/built-in-functions/async/asyncallapply.md)
* [AsyncAny](/boxlang-language/reference/built-in-functions/async/asyncany.md)
* [AsyncRun](/boxlang-language/reference/built-in-functions/async/asyncrun.md)
* [ExecutorDelete](/boxlang-language/reference/built-in-functions/async/executordelete.md)
* [ExecutorGet](/boxlang-language/reference/built-in-functions/async/executorget.md)
* [ExecutorHas](/boxlang-language/reference/built-in-functions/async/executorhas.md)
* [ExecutorList](/boxlang-language/reference/built-in-functions/async/executorlist.md)
* [ExecutorShutdown](/boxlang-language/reference/built-in-functions/async/executorshutdown.md)
* [ExecutorStatus](/boxlang-language/reference/built-in-functions/async/executorstatus.md)
* [FutureNew](/boxlang-language/reference/built-in-functions/async/futurenew.md)
* [IsInThread](/boxlang-language/reference/built-in-functions/async/isinthread.md)
* [isThreadAlive](/boxlang-language/reference/built-in-functions/async/isthreadalive.md)
* [IsThreadInterrupted](/boxlang-language/reference/built-in-functions/async/isthreadinterrupted.md)
* [RunAsync](/boxlang-language/reference/built-in-functions/async/runasync.md)
* [ThreadCurrent](/boxlang-language/reference/built-in-functions/async/threadcurrent.md)
* [ThreadInterrupt](/boxlang-language/reference/built-in-functions/async/threadinterrupt.md)
* [ThreadJoin](/boxlang-language/reference/built-in-functions/async/threadjoin.md)
* [ThreadNew](/boxlang-language/reference/built-in-functions/async/threadnew.md)
* [ThreadTerminate](/boxlang-language/reference/built-in-functions/async/threadterminate.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/async/executornew.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
